#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy2 Experiment Builder (v1.79.01), Tue Feb  4 14:44:28 2014
If you publish work using this script please cite the relevant PsychoPy publications
  Peirce, JW (2007) PsychoPy - Psychophysics software in Python. Journal of Neuroscience Methods, 162(1-2), 8-13.
  Peirce, JW (2009) Generating stimuli for neuroscience using PsychoPy. Frontiers in Neuroinformatics, 2:10. doi: 10.3389/neuro.11.010.2008
"""

from __future__ import division  # so that 1/3=0.333 instead of 1/3=0
from psychopy import visual, core, data, event, logging, sound, gui
from psychopy.constants import *  # things like STARTED, FINISHED
import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import sin, cos, tan, log, log10, pi, average, sqrt, std, deg2rad, rad2deg, linspace, asarray
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions

# Store info about the experiment session
expName = 'FaceRecognitionExp'  # from the Builder filename that created this script
expInfo = {u'session': u'001', u'participant': u''}
dlg = gui.DlgFromDict(dictionary=expInfo, title=expName)
if dlg.OK == False: core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName

# Setup files for saving
if not os.path.isdir('data'):
    os.makedirs('data')  # if this fails (e.g. permissions) we will get error
filename = 'data' + os.path.sep + '%s_%s' %(expInfo['participant'], expInfo['date'])
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath=u'/Users/lharvey/Documents/Word Docs/Classes/Psych 4165/PSYC4165 2014 1 Spring/PSYC_4165-100 2014 Spring Labs/2. Detection Theory Lab/Lab_2_Tools/Face-Eyes Experiment/FaceRecognitionExperiment.psyexp',
    savePickle=True, saveWideText=True,
    dataFileName=filename)

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(size=(2560, 1440), fullscr=True, screen=0, allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb')
# store frame rate of monitor if we can measure it successfully
expInfo['frameRate']=win.getActualFrameRate()
if expInfo['frameRate']!=None:
    frameDur = 1.0/round(expInfo['frameRate'])
else:
    frameDur = 1.0/60.0 # couldn't get a reliable measure so guess

# Initialize components for Routine "learnInstructions"
learnInstructionsClock = core.Clock()
instructions1 = visual.TextStim(win=win, ori=0, name='instructions1',
    text='You will be shown 64 faces for 2 sec each. Try to remember each face. You will be asked to recognize them later. Press space key to continue.',    font='Arial',
    pos=[0, 0], height=0.1, wrapWidth=None,
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "trial"
trialClock = core.Clock()
learningImage = visual.ImageStim(win=win, name='learningImage',
    image='sin', mask=None,
    ori=0, pos=[0, 0], size=None,
    color=[1,1,1], colorSpace='rgb', opacity=1,
    texRes=128, interpolate=True, depth=0.0)
text_2 = visual.TextStim(win=win, ori=0, name='text_2',
    text='nonsense',    font='Arial',
    pos=[0, .35], height=0.05, wrapWidth=None,
    color='white', colorSpace='rgb', opacity=0.5,
    depth=-1.0)

# Initialize components for Routine "testInstructions"
testInstructionsClock = core.Clock()
testInstructions1 = visual.TextStim(win=win, ori=0, name='testInstructions1',
    text='You will be presented 128 faces. Half of them are the previous faces; half are new faces. Use a 6 point confidence scale to judge whether or not you have seen the face before.\n1 = certain new face\n2 = new face\n3 = guess new face\n4 = guess old face\n5 = old face\n6 = certain old face\n\nPress space key to start the test trials.',    font='Arial',
    pos=[0, 0], height=0.1, wrapWidth=None,
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0)

# Initialize components for Routine "testTrial"
testTrialClock = core.Clock()
testImage = visual.ImageStim(win=win, name='testImage',
    image='sin', mask=None,
    ori=0, pos=[0, 0], size=None,
    color=[1,1,1], colorSpace='rgb', opacity=1,
    texRes=128, interpolate=True, depth=0.0)
text = visual.TextStim(win=win, ori=0, name='text',
    text='nonsense',    font='Arial',
    pos=[0, .35], height=0.05, wrapWidth=None,
    color='white', colorSpace='rgb', opacity=0.5,
    depth=-2.0)

# Initialize components for Routine "thankYou"
thankYouClock = core.Clock()
thankYouText = visual.TextStim(win=win, ori=0, name='thankYouText',
    text='The experiment is over.\nThank you for participating.\nPress the space bar to quit.',    font='Arial',
    pos=[0, 0], height=0.1, wrapWidth=None,
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0)

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

#------Prepare to start Routine "learnInstructions"-------
t = 0
learnInstructionsClock.reset()  # clock 
frameN = -1
# update component parameters for each repeat
key_resp1 = event.BuilderKeyResponse()  # create an object of type KeyResponse
key_resp1.status = NOT_STARTED
# keep track of which components have finished
learnInstructionsComponents = []
learnInstructionsComponents.append(instructions1)
learnInstructionsComponents.append(key_resp1)
for thisComponent in learnInstructionsComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

#-------Start Routine "learnInstructions"-------
continueRoutine = True
while continueRoutine:
    # get current time
    t = learnInstructionsClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *instructions1* updates
    if t >= 0.0 and instructions1.status == NOT_STARTED:
        # keep track of start time/frame for later
        instructions1.tStart = t  # underestimates by a little under one frame
        instructions1.frameNStart = frameN  # exact frame index
        instructions1.setAutoDraw(True)
    
    # *key_resp1* updates
    if t >= 0.0 and key_resp1.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp1.tStart = t  # underestimates by a little under one frame
        key_resp1.frameNStart = frameN  # exact frame index
        key_resp1.status = STARTED
        # keyboard checking is just starting
        event.clearEvents()
    if key_resp1.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineTimer.reset()  # if we abort early the non-slip timer needs reset
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in learnInstructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the [Esc] key)
    if event.getKeys(["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()
    else:  # this Routine was not non-slip safe so reset non-slip timer
        routineTimer.reset()

#-------Ending Routine "learnInstructions"-------
for thisComponent in learnInstructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# set up handler to look after randomisation of conditions etc
learnTrials = data.TrialHandler(nReps=1, method='random', 
    extraInfo=expInfo, originPath=u'/Users/lharvey/Documents/Word Docs/Classes/Psych 4165/PSYC4165 2014 1 Spring/PSYC_4165-100 2014 Spring Labs/2. Detection Theory Lab/Lab_2_Tools/Face-Eyes Experiment/FaceRecognitionExperiment.psyexp',
    trialList=data.importConditions('conditions/ConditionsLearn1.xlsx'),
    seed=None, name='learnTrials')
thisExp.addLoop(learnTrials)  # add the loop to the experiment
thisLearnTrial = learnTrials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb=thisLearnTrial.rgb)
if thisLearnTrial != None:
    for paramName in thisLearnTrial.keys():
        exec(paramName + '= thisLearnTrial.' + paramName)

for thisLearnTrial in learnTrials:
    currentLoop = learnTrials
    # abbreviate parameter names if possible (e.g. rgb = thisLearnTrial.rgb)
    if thisLearnTrial != None:
        for paramName in thisLearnTrial.keys():
            exec(paramName + '= thisLearnTrial.' + paramName)
    
    #------Prepare to start Routine "trial"-------
    t = 0
    trialClock.reset()  # clock 
    frameN = -1
    routineTimer.add(2.500000)
    # update component parameters for each repeat
    # keep track of which components have finished
    trialComponents = []
    trialComponents.append(learningImage)
    trialComponents.append(text_2)
    for thisComponent in trialComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    #-------Start Routine "trial"-------
    continueRoutine = True
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = trialClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *learningImage* updates
        if t >= 0.5 and learningImage.status == NOT_STARTED:
            # keep track of start time/frame for later
            learningImage.tStart = t  # underestimates by a little under one frame
            learningImage.frameNStart = frameN  # exact frame index
            learningImage.setAutoDraw(True)
        elif learningImage.status == STARTED and t >= (0.5 + 2.0):
            learningImage.setAutoDraw(False)
        if learningImage.status == STARTED:  # only update if being drawn
            learningImage.setImage(Stimulus, log=False)
        
        # *text_2* updates
        if t >= 0 and text_2.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_2.tStart = t  # underestimates by a little under one frame
            text_2.frameNStart = frameN  # exact frame index
            text_2.setAutoDraw(True)
        elif text_2.status == STARTED and t >= (0 + 2.5):
            text_2.setAutoDraw(False)
        if text_2.status == STARTED:  # only update if being drawn
            text_2.setText(str(learnTrials.thisN + 1) + " / " + str(learnTrials.nTotal), log=False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineTimer.reset()  # if we abort early the non-slip timer needs reset
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the [Esc] key)
        if event.getKeys(["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    #-------Ending Routine "trial"-------
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    thisExp.nextEntry()
    
# completed 1 repeats of 'learnTrials'

# get names of stimulus parameters
if learnTrials.trialList in ([], [None], None):  params = []
else:  params = learnTrials.trialList[0].keys()
# save data for this loop
learnTrials.saveAsExcel(filename + '.xlsx', sheetName='learnTrials',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

#------Prepare to start Routine "testInstructions"-------
t = 0
testInstructionsClock.reset()  # clock 
frameN = -1
# update component parameters for each repeat
key_resp2 = event.BuilderKeyResponse()  # create an object of type KeyResponse
key_resp2.status = NOT_STARTED
# keep track of which components have finished
testInstructionsComponents = []
testInstructionsComponents.append(testInstructions1)
testInstructionsComponents.append(key_resp2)
for thisComponent in testInstructionsComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

#-------Start Routine "testInstructions"-------
continueRoutine = True
while continueRoutine:
    # get current time
    t = testInstructionsClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *testInstructions1* updates
    if t >= 0.0 and testInstructions1.status == NOT_STARTED:
        # keep track of start time/frame for later
        testInstructions1.tStart = t  # underestimates by a little under one frame
        testInstructions1.frameNStart = frameN  # exact frame index
        testInstructions1.setAutoDraw(True)
    
    # *key_resp2* updates
    if t >= 0.5 and key_resp2.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp2.tStart = t  # underestimates by a little under one frame
        key_resp2.frameNStart = frameN  # exact frame index
        key_resp2.status = STARTED
        # keyboard checking is just starting
        event.clearEvents()
    if key_resp2.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineTimer.reset()  # if we abort early the non-slip timer needs reset
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in testInstructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the [Esc] key)
    if event.getKeys(["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()
    else:  # this Routine was not non-slip safe so reset non-slip timer
        routineTimer.reset()

#-------Ending Routine "testInstructions"-------
for thisComponent in testInstructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# set up handler to look after randomisation of conditions etc
testTrials = data.TrialHandler(nReps=1, method='random', 
    extraInfo=expInfo, originPath=u'/Users/lharvey/Documents/Word Docs/Classes/Psych 4165/PSYC4165 2014 1 Spring/PSYC_4165-100 2014 Spring Labs/2. Detection Theory Lab/Lab_2_Tools/Face-Eyes Experiment/FaceRecognitionExperiment.psyexp',
    trialList=data.importConditions('conditions/ConditionsTest1.xlsx'),
    seed=None, name='testTrials')
thisExp.addLoop(testTrials)  # add the loop to the experiment
thisTestTrial = testTrials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb=thisTestTrial.rgb)
if thisTestTrial != None:
    for paramName in thisTestTrial.keys():
        exec(paramName + '= thisTestTrial.' + paramName)

for thisTestTrial in testTrials:
    currentLoop = testTrials
    # abbreviate parameter names if possible (e.g. rgb = thisTestTrial.rgb)
    if thisTestTrial != None:
        for paramName in thisTestTrial.keys():
            exec(paramName + '= thisTestTrial.' + paramName)
    
    #------Prepare to start Routine "testTrial"-------
    t = 0
    testTrialClock.reset()  # clock 
    frameN = -1
    # update component parameters for each repeat
    response = event.BuilderKeyResponse()  # create an object of type KeyResponse
    response.status = NOT_STARTED
    # keep track of which components have finished
    testTrialComponents = []
    testTrialComponents.append(testImage)
    testTrialComponents.append(response)
    testTrialComponents.append(text)
    for thisComponent in testTrialComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    #-------Start Routine "testTrial"-------
    continueRoutine = True
    while continueRoutine:
        # get current time
        t = testTrialClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *testImage* updates
        if t >= 0.5 and testImage.status == NOT_STARTED:
            # keep track of start time/frame for later
            testImage.tStart = t  # underestimates by a little under one frame
            testImage.frameNStart = frameN  # exact frame index
            testImage.setAutoDraw(True)
        if testImage.status == STARTED:  # only update if being drawn
            testImage.setImage(Stimulus, log=False)
        
        # *response* updates
        if t >= 0.6 and response.status == NOT_STARTED:
            # keep track of start time/frame for later
            response.tStart = t  # underestimates by a little under one frame
            response.frameNStart = frameN  # exact frame index
            response.status = STARTED
            # keyboard checking is just starting
            response.clock.reset()  # now t=0
            event.clearEvents()
        if response.status == STARTED:
            theseKeys = event.getKeys(keyList=['1', '2', '3', '4', '5', '6'])
            if len(theseKeys) > 0:  # at least one key was pressed
                response.keys = theseKeys[-1]  # just the last key pressed
                response.rt = response.clock.getTime()
                # a response ends the routine
                continueRoutine = False
        
        # *text* updates
        if t >= 0.0 and text.status == NOT_STARTED:
            # keep track of start time/frame for later
            text.tStart = t  # underestimates by a little under one frame
            text.frameNStart = frameN  # exact frame index
            text.setAutoDraw(True)
        if text.status == STARTED:  # only update if being drawn
            text.setText(str(testTrials.thisN + 1) + " / " + str(testTrials.nTotal), log=False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineTimer.reset()  # if we abort early the non-slip timer needs reset
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in testTrialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the [Esc] key)
        if event.getKeys(["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
        else:  # this Routine was not non-slip safe so reset non-slip timer
            routineTimer.reset()
    
    #-------Ending Routine "testTrial"-------
    for thisComponent in testTrialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if response.keys in ['', [], None]:  # No response was made
       response.keys=None
    # store data for testTrials (TrialHandler)
    testTrials.addData('response.keys',response.keys)
    if response.keys != None:  # we had a response
        testTrials.addData('response.rt', response.rt)
    thisExp.nextEntry()
    
# completed 1 repeats of 'testTrials'

# get names of stimulus parameters
if testTrials.trialList in ([], [None], None):  params = []
else:  params = testTrials.trialList[0].keys()
# save data for this loop
testTrials.saveAsExcel(filename + '.xlsx', sheetName='testTrials',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

#------Prepare to start Routine "thankYou"-------
t = 0
thankYouClock.reset()  # clock 
frameN = -1
# update component parameters for each repeat
key_resp4 = event.BuilderKeyResponse()  # create an object of type KeyResponse
key_resp4.status = NOT_STARTED
# keep track of which components have finished
thankYouComponents = []
thankYouComponents.append(thankYouText)
thankYouComponents.append(key_resp4)
for thisComponent in thankYouComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

#-------Start Routine "thankYou"-------
continueRoutine = True
while continueRoutine:
    # get current time
    t = thankYouClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *thankYouText* updates
    if t >= 0.0 and thankYouText.status == NOT_STARTED:
        # keep track of start time/frame for later
        thankYouText.tStart = t  # underestimates by a little under one frame
        thankYouText.frameNStart = frameN  # exact frame index
        thankYouText.setAutoDraw(True)
    
    # *key_resp4* updates
    if t >= 0.0 and key_resp4.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp4.tStart = t  # underestimates by a little under one frame
        key_resp4.frameNStart = frameN  # exact frame index
        key_resp4.status = STARTED
        # keyboard checking is just starting
        event.clearEvents()
    if key_resp4.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineTimer.reset()  # if we abort early the non-slip timer needs reset
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in thankYouComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the [Esc] key)
    if event.getKeys(["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()
    else:  # this Routine was not non-slip safe so reset non-slip timer
        routineTimer.reset()

#-------Ending Routine "thankYou"-------
for thisComponent in thankYouComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
win.close()
core.quit()
